#!/bin/bash
#
#set -x

echo ""
echo ""
echo "******************** IMPORTANT *************************"
echo "********************************************************"
echo "** DO NOT CUT OFF the main AC power of bullion server **"
echo "** during the the EMM / FPGA update                   **"
echo "** the server MUST BE IN 'STANDBY' MODE (= POWER OFF) **"
echo "********************************************************"
echo ""

echo "===================================================="
echo "============  Start update of MXB FPGA ============="
echo "===================================================="
echo ""
echo "************* The current version is : *************" 
./ipmitool -H $1 -U $2 -P $3 bulloem ver MXBC_FUNC 0 > resu
cat resu
grep C.4.5.0.02.04 resu  > /dev/null
ret_cmd=$?
if [ $ret_cmd -ne 0 ] ; then

./ipmitool -H $1 -U $2 -P $3 bulloem upgrade ./FPGA/FPGA_EMM_MXBC6_C4500204.HEX MXBC_FUNC 0
ret_cmd=$?
if [ $ret_cmd -ne 0 ] ; then
echo ""
echo "**************************************************"
echo "* An error has occured, check the messages above *"
echo "* The firmware upgrade is not fully completed    *"
echo "**************************************************"
echo ""
	exit 1
fi

else
echo "============  No need to update MXB FPGA  =============="
fi

echo "************* The New version is : ************* "
./ipmitool -H $1 -U $2 -P $3 bulloem ver MXBC_FUNC 0 > resu
cat resu

echo "===================================================="
echo "============  End update of MXB FPGA   ============="
echo "===================================================="
echo "============ Start update of ILB FPGA  ============="
echo "===================================================="
echo ""
echo "************* The current version is : *************" 
./ipmitool -H $1 -U $2 -P $3 bulloem ver ILBC_FUNC 0 > resu
cat resu
grep B.4.5.0.02.06 resu > /dev/null
ret_cmd=$?
if [ $ret_cmd -ne 0 ] ; then

./ipmitool -H $1 -U $2 -P $3 bulloem upgrade ./FPGA/FPGA_EMM_ILBC3_B4500206.HEX ILBC_FUNC 0
ret_cmd=$?

if [ $ret_cmd -ne 0 ] ; then
echo ""
echo "**************************************************"
echo "* An error has occured, check the messages above *"
echo "* The firmware upgrade is not fully completed    *"
echo "**************************************************"
echo ""
	exit 1
fi

else
echo "============  No need to update ILB FPGA  =============="
fi

echo "************* The New version is : *************"
./ipmitool -H $1 -U $2 -P $3 bulloem ver ILBC_FUNC 0 > resu
cat resu
echo "===================================================="
echo "============  End update of ILB FPGA  =============="
echo "===================================================="
echo "============   Start update of BMC    =============="
echo "===================================================="

echo "************* The current version is : *************" 
./ipmitool -H $1 -U $2 -P $3 bulloem ver BMC 0 > resu
cat resu
grep 11.12.0 resu > /dev/null
ret_cmd=$?
if [ $ret_cmd -ne 0 ] ; then

./ipmitool -H $1 -U $2 -P $3 bulloem upgrade ./EMM/fw-wub-wpcm450_bulldc_MESCA_111200_1207.bin BMC 0
ret_cmd=$?
if [ $ret_cmd -ne 0 ] ; then
echo ""
echo "**************************************************"
echo "* An error has occured, check the messages above *"
echo "* The firmware upgrade is not fully completed    *"
echo "**************************************************"
echo ""
	exit 1
fi

else
echo "============  No need to update BMC  =============="
fi

echo "===================================================="
echo "=============    End update of BMC     ============="
echo "===================================================="
echo ""
./ipmitool -H $1 -U $2 -P $3 bmc reset cold > resu
echo "************************************************"
echo "***      Automatic BMC reset started.        ***"
echo "***    Please wait a few minutes before      ***"
echo "*** to reconnect the System Hardware Console ***"
echo "************************************************"

